#include <stdio.h>
#include <sys/ioctl.h>
#include <rpc/rpc.h>
#include <math.h>
#include "ahhead.h"

		/*  fortran-c interface routine */

xdrf_ahopen1_(iunit,file_name,size1,mode,ierr)
	char *file_name;
	int *iunit,*mode,*ierr,*size1;
{
	file_name[*size1]= '\0';
	*ierr = xdr_ahopen(*iunit,file_name,*mode);
	return;
}
xdrf_ahclose_(iunit,ierr)
	int *iunit,*ierr;
{
	*ierr=xdr_ahclose(*iunit);
	return;
}
xdrf_rewind_(iunit,n,ierr)
int *iunit,*n,*ierr;
{
	*ierr = xdr_rewind(*iunit,*n);
	return;
}
xdrf_rdahhead1_(iunit,ierr,
	codeah,chanah,typeah,slatah,slonah,elevah,dsah,a0ah,xnpah,nu1,xnzah,nu2,
	pz,elatah,elonah,edepah,ieyrah,iemoah,iedaah,iehrah,iemnah,esecah,ecomah,itypah,ndatah,
	deltah,amaxah,isyrah,ismoah,isdaah,ishrah,ismnah,ssecah,rminah,scomah,logah,dumah)

	char            codeah[CODESIZE]; /* station code         */
	char            chanah[CHANSIZE]; /* lpz,spn, etc.        */
	char            typeah[STYPESIZE];/* wwssn,hglp,etc.     */
	float           *slatah;           /* station latitude     */
	float           *slonah;           /*    "    longitude    */
	float           *elevah;           /*    "    elevation    */
	float           *dsah;    /* gain */
	float           *a0ah;    /* normalization */
	float 		*xnpah,*xnzah; /* number of pole & zero */
	int 		*nu1,*nu2; /* filler */
	complex 	pz[2*(NOCALPTS-1)];      /* calibration info */
	float           *elatah;            /* event latitude       */
	float           *elonah;            /*   "   longitude      */
	float           *edepah;            /*   "   depth          */
	short           *ieyrah;     /* year         */
	short           *iemoah;     /* month        */
	short           *iedaah;    /* day          */
	short           *iehrah;     /* hour         */
	short           *iemnah;     /* minute       */
	float           *esecah;    /* second       */
	char            ecomah[COMSIZE];      /*      comment line */
	short           *itypah;   /* data type (int,float,...)    */
	long            *ndatah;  /* number of samples            */
	float           *deltah;  /* sampling interval            */
	float           *amaxah; /* maximum amplitude of record  */
	short           *isyrah;     /* year         */
	short           *ismoah;     /* month        */
	short           *isdaah;    /* day          */
	short           *ishrah;     /* hour         */
	short           *ismnah;     /* minute       */
	float           *ssecah;    /* second       */
	float           *rminah;   /* minimum value of abscissa    */
	char            scomah[COMSIZE];      /* comment line      */
	char            logah[LOGSIZE]; /* log of data manipulations */
	float           dumah[NEXTRAS]; /* freebies */

	int *iunit,*ierr;
{
	*ierr = xdr_rdahhead(*iunit,
	codeah,chanah,typeah,slatah,slonah,elevah,dsah,a0ah,xnpah,nu1,xnzah,nu2,
	pz,elatah,elonah,edepah,ieyrah,iemoah,iedaah,iehrah,iemnah,esecah,ecomah,itypah,ndatah,
	deltah,amaxah,isyrah,ismoah,isdaah,ishrah,ismnah,ssecah,rminah,scomah,logah,dumah);
	return;
}
xdrf_rdahrecord1_(test,iunit,ierr,
	codeah,chanah,typeah,slatah,slonah,elevah,dsah,a0ah,xnpah,nu1,xnzah,nu2,
	pz,elatah,elonah,edepah,ieyrah,iemoah,iedaah,iehrah,iemnah,esecah,ecomah,itypah,ndatah,
	deltah,amaxah,isyrah,ismoah,isdaah,ishrah,ismnah,ssecah,rminah,scomah,logah,dumah,array)

	char            codeah[CODESIZE]; /* station code         */
	char            chanah[CHANSIZE]; /* lpz,spn, etc.        */
	char            typeah[STYPESIZE];/* wwssn,hglp,etc.     */
	float           *slatah;           /* station latitude     */
	float           *slonah;           /*    "    longitude    */
	float           *elevah;           /*    "    elevation    */
	float           *dsah;    /* gain */
	float           *a0ah;    /* normalization */
	float 		*xnpah,*xnzah; /* number of pole & zero */
	int 		*nu1,*nu2; /* filler */
	complex 	pz[2*(NOCALPTS-1)];      /* calibration info */
	float           *elatah;            /* event latitude       */
	float           *elonah;            /*   "   longitude      */
	float           *edepah;            /*   "   depth          */
	short           *ieyrah;     /* year         */
	short           *iemoah;     /* month        */
	short           *iedaah;    /* day          */
	short           *iehrah;     /* hour         */
	short           *iemnah;     /* minute       */
	float           *esecah;    /* second       */
	char            ecomah[COMSIZE];      /*      comment line */
	short           *itypah;   /* data type (int,float,...)    */
	long            *ndatah;  /* number of samples            */
	float           *deltah;  /* sampling interval            */
	float           *amaxah; /* maximum amplitude of record  */
	short           *isyrah;     /* year         */
	short           *ismoah;     /* month        */
	short           *isdaah;    /* day          */
	short           *ishrah;     /* hour         */
	short           *ismnah;     /* minute       */
	float           *ssecah;    /* second       */
	float           *rminah;   /* minimum value of abscissa    */
	char            scomah[COMSIZE];      /* comment line      */
	char            logah[LOGSIZE]; /* log of data manipulations */
	float           dumah[NEXTRAS]; /* freebies */

	int *iunit,*ierr;
	float *array;
	float *test;
{
	*ierr = xdr_rdahrecord(test,*iunit,
	codeah,chanah,typeah,slatah,slonah,elevah,dsah,a0ah,xnpah,nu1,xnzah,nu2,
	pz,elatah,elonah,edepah,ieyrah,iemoah,iedaah,iehrah,iemnah,esecah,ecomah,itypah,ndatah,
	deltah,amaxah,isyrah,ismoah,isdaah,ishrah,ismnah,ssecah,rminah,scomah,logah,dumah,array);
	return;
}
xdrf_rdahdata_(iunit,array,itype,ndata,ierr)
char *array;
int *ndata,*ierr,*iunit;
short *itype;
{
	*ierr = xdr_rdahdata( *iunit, array, *itype, *ndata);
	return;
}
xdrf_wrahhead1_( iunit, ierr, 
	codeah,chanah,typeah,slatah,slonah,elevah,dsah,a0ah,xnpah,nu1,xnzah,nu2,  
	pz,elatah,elonah,edepah,ieyrah,iemoah,iedaah,iehrah,iemnah,esecah,ecomah,itypah,ndatah,  
	deltah,amaxah,isyrah,ismoah,isdaah,ishrah,ismnah,ssecah,rminah,scomah,logah,dumah )

	char            codeah[CODESIZE]; /* station code         */
	char            chanah[CHANSIZE]; /* lpz,spn, etc.        */
	char            typeah[STYPESIZE];/* wwssn,hglp,etc.     */
	float           *slatah;           /* station latitude     */
	float           *slonah;           /*    "    longitude    */
	float           *elevah;           /*    "    elevation    */
	float           *dsah;    /* gain */
	float           *a0ah;    /* normalization */
	float 		*xnpah,*xnzah; /* number of pole & zero */
	int 		*nu1,*nu2; /* filler */
	complex 	pz[2*(NOCALPTS-1)];      /* calibration info */
	float           *elatah;            /* event latitude       */
	float           *elonah;            /*   "   longitude      */
	float           *edepah;            /*   "   depth          */
	short           *ieyrah;     /* year         */
	short           *iemoah;     /* month        */
	short           *iedaah;    /* day          */
	short           *iehrah;     /* hour         */
	short           *iemnah;     /* minute       */
	float           *esecah;    /* second       */
	char            ecomah[COMSIZE];      /*      comment line */
	short           *itypah;   /* data type (int,float,...)    */
	long            *ndatah;  /* number of samples            */
	float           *deltah;  /* sampling interval            */
	float           *amaxah; /* maximum amplitude of record  */
	short           *isyrah;     /* year         */
	short           *ismoah;     /* month        */
	short           *isdaah;    /* day          */
	short           *ishrah;     /* hour         */
	short           *ismnah;     /* minute       */
	float           *ssecah;    /* second       */
	float           *rminah;   /* minimum value of abscissa    */
	char            scomah[COMSIZE];      /* comment line      */
	char            logah[LOGSIZE]; /* log of data manipulations */
	float           dumah[NEXTRAS]; /* freebies */

	int *iunit,*ierr;
{
	*ierr = xdr_wrahhead( *iunit, 
	codeah,chanah,typeah,slatah,slonah,elevah,dsah,a0ah,xnpah,nu1,xnzah,nu2,  
	pz,elatah,elonah,edepah,ieyrah,iemoah,iedaah,iehrah,iemnah,esecah,ecomah,itypah,ndatah,  
	deltah,amaxah,isyrah,ismoah,isdaah,ishrah,ismnah,ssecah,rminah,scomah,logah,dumah );
	return;
}
xdrf_wrahrecord1_( iunit, ierr, 
	codeah,chanah,typeah,slatah,slonah,elevah,dsah,a0ah,xnpah,nu1,xnzah,nu2,  
	pz,elatah,elonah,edepah,ieyrah,iemoah,iedaah,iehrah,iemnah,esecah,ecomah,itypah,ndatah,  
	deltah,amaxah,isyrah,ismoah,isdaah,ishrah,ismnah,ssecah,rminah,scomah,logah,dumah,array )

	char            codeah[CODESIZE]; /* station code         */
	char            chanah[CHANSIZE]; /* lpz,spn, etc.        */
	char            typeah[STYPESIZE];/* wwssn,hglp,etc.     */
	float           *slatah;           /* station latitude     */
	float           *slonah;           /*    "    longitude    */
	float           *elevah;           /*    "    elevation    */
	float           *dsah;    /* gain */
	float           *a0ah;    /* normalization */
	float 		*xnpah,*xnzah; /* number of pole & zero */
	int 		*nu1,*nu2; /* filler */
	complex 	pz[2*(NOCALPTS-1)];      /* calibration info */
	float           *elatah;            /* event latitude       */
	float           *elonah;            /*   "   longitude      */
	float           *edepah;            /*   "   depth          */
	short           *ieyrah;     /* year         */
	short           *iemoah;     /* month        */
	short           *iedaah;    /* day          */
	short           *iehrah;     /* hour         */
	short           *iemnah;     /* minute       */
	float           *esecah;    /* second       */
	char            ecomah[COMSIZE];      /*      comment line */
	short           *itypah;   /* data type (int,float,...)    */
	long            *ndatah;  /* number of samples            */
	float           *deltah;  /* sampling interval            */
	float           *amaxah; /* maximum amplitude of record  */
	short           *isyrah;     /* year         */
	short           *ismoah;     /* month        */
	short           *isdaah;    /* day          */
	short           *ishrah;     /* hour         */
	short           *ismnah;     /* minute       */
	float           *ssecah;    /* second       */
	float           *rminah;   /* minimum value of abscissa    */
	char            scomah[COMSIZE];      /* comment line      */
	char            logah[LOGSIZE]; /* log of data manipulations */
	float           dumah[NEXTRAS]; /* freebies */

	int *iunit,*ierr;
	char *array;	
{
	*ierr = xdr_wrahrecord( *iunit, 
	codeah,chanah,typeah,slatah,slonah,elevah,dsah,a0ah,xnpah,nu1,xnzah,nu2,  
	pz,elatah,elonah,edepah,ieyrah,iemoah,iedaah,iehrah,iemnah,esecah,ecomah,itypah,ndatah,  
	deltah,amaxah,isyrah,ismoah,isdaah,ishrah,ismnah,ssecah,rminah,scomah,logah,dumah,array );
	return;
}
xdrf_wrahdata_(iunit,array,itype,ndata,ierr)
char *array;
short *itype;
int *ndata,*ierr,*iunit;
{
	*ierr = xdr_wrahdata(*iunit, array,*itype,*ndata);
	return;
}
